#pragma once

#include "ControlledMotor.h"
#include "DistanceSensor.h"
#include "Motor.h"
#include "Thing.h"
#include "Vector2.h"
#include "Vector3.h"

namespace Passer {
namespace RoboidControl {

class Placement {
 public:
  Placement();
  Placement(Thing* thing, Vector3 position);
  Placement(Thing* thing, Vector3 position, float horizontalAngle);
  Placement(Thing* thing, float horizontalAngle);

  Placement* parent = nullptr;
  Placement** children = nullptr;
  unsigned int childCount = 0;

  Vector3 position;
  Vector3 direction;
  Thing* thing;
};

}  // namespace RoboidControl
}  // namespace Passer
using namespace Passer::RoboidControl;